/*
 * JTreeBoxProperties.java
 *
 * Created on November 12, 2004, 12:58 PM
 */

package edu.umiacs.fmm.gui.dialog;
import javax.swing.tree.*;
import edu.umiacs.fmm.*;
import java.util.*;
/**
 *
 * @author  wpwy
 */
public class TreeModelBoxProperties extends DefaultTreeModel{
    
    /** Creates a new instance of JTreeBoxProperties */
    public TreeModelBoxProperties(TreeNode root) {
        super(root);
    }
    
    public TreeModelBoxProperties(Box b, FmmTree t) {
        super(null);
        if (b!=null && t!=null){
            //String rootLabel = "Box "+b.getLabel();
            
            DefaultMutableTreeNode myRoot = new DefaultMutableTreeNode(b);
            this.setRoot(myRoot);
            
            DefaultMutableTreeNode childrenNode = new DefaultMutableTreeNode("Children");
            myRoot.add(childrenNode);
            Vector<Box> childrenBoxes = b.getChildren();
            if (childrenBoxes==null)
                childrenNode.add(new DefaultMutableTreeNode("None"));
            else {
                for (Box bb:childrenBoxes)
                    childrenNode.add(new DefaultMutableTreeNode(bb));
            }
            
            DefaultMutableTreeNode neighborsNode = new DefaultMutableTreeNode("Neighbors");
            myRoot.add(neighborsNode);
            Vector<Box> neighborBoxes = b.getNeighbors(t);
            if (neighborBoxes==null)
                neighborsNode.add(new DefaultMutableTreeNode("None"));
            else {
                for (Box bb:neighborBoxes)
                    neighborsNode.add(new DefaultMutableTreeNode(bb));
            }
            
            DefaultMutableTreeNode l1neighborsNode = new DefaultMutableTreeNode("L1 Neighborhood");
            myRoot.add(l1neighborsNode);
            Vector<Box> l1neighborBoxes = b.getL1();
            if (l1neighborBoxes==null)
                l1neighborsNode.add(new DefaultMutableTreeNode("None"));
            else {
                for (Box bb:l1neighborBoxes)
                    l1neighborsNode.add(new DefaultMutableTreeNode(bb));
            }
            DefaultMutableTreeNode l2neighborsNode = new DefaultMutableTreeNode("L2 Neighborhood");
            myRoot.add(l2neighborsNode);
            Vector<Box> l2neighborBoxes = b.getL2();
            if (l2neighborBoxes==null)
                l2neighborsNode.add(new DefaultMutableTreeNode("None"));
            else {
                for (Box bb:l2neighborBoxes)
                    l2neighborsNode.add(new DefaultMutableTreeNode(bb));
            }
            DefaultMutableTreeNode l3neighborsNode = new DefaultMutableTreeNode("L3 Neighborhood");
            myRoot.add(l3neighborsNode);
            Vector<Box> l3neighborBoxes = b.getL3();
            if (l3neighborBoxes==null)
                l3neighborsNode.add(new DefaultMutableTreeNode("None"));
            else {
                for (Box bb:l3neighborBoxes)
                    l3neighborsNode.add(new DefaultMutableTreeNode(bb));
            }
            DefaultMutableTreeNode l4neighborsNode = new DefaultMutableTreeNode("L4 Neighborhood");
            myRoot.add(l4neighborsNode);
            Vector<Box> l4neighborBoxes = b.getL4();
            if (l4neighborBoxes==null)
                l4neighborsNode.add(new DefaultMutableTreeNode("None"));
            else {
                for (Box bb:l4neighborBoxes)
                    l4neighborsNode.add(new DefaultMutableTreeNode(bb));
            }
            
            DefaultMutableTreeNode sourceNode = new DefaultMutableTreeNode("Source Pts (X)");
            myRoot.add(sourceNode);
            Vector<Point> x = b.getXRecursive();
            if (x.size()==0)
                sourceNode.add(new DefaultMutableTreeNode("None"));
            else {
                for (Point p:x)
                    sourceNode.add(new DefaultMutableTreeNode(p));
            }
            
            DefaultMutableTreeNode targetNode = new DefaultMutableTreeNode("Target Pts (Y)");
            myRoot.add(targetNode);
            Vector<Point> y = b.getYRecursive();
            if (y.size()==0)
                targetNode.add(new DefaultMutableTreeNode("None"));
            else {
                for (Point p:y)
                    targetNode.add(new DefaultMutableTreeNode(p));
            }
        }
    }
    
}
